/*
 * ConfigurationLoader.java
 *
 * Created on 28. April 2002, 14:41
 */

package org.jconfig.handler;

import org.jconfig.Configuration;
import org.jconfig.ConfigurationManagerException;
/**
 * This interface defines all methods that must be implemented
 * by all Handler classes.
 *
 * @author  Andreas Mecky <andreas.mecky@xcom.de>
 * @author Terry Dye <terry.dye@xcom.de>
 */
public interface ConfigurationHandler {
    
    /**
     * This method loads a configuration and returns it
     */
    public Configuration load(String configurationName) throws ConfigurationManagerException;
    /**
     * This method should store all categories and properties.
     * @throws ConfigurationManagerException  */
    public void store(Configuration configuration) throws ConfigurationManagerException;
    
}

