/*
 * ConfigurationTest.java
 *
 * Created on 19. November 2002, 22:37
 */
package org.jconfig;

import java.io.File;
import org.jconfig.handler.XMLFileHandler;
import junit.framework.TestCase;
import java.util.Properties;
import org.jconfig.parser.NestedConfigParser;
/**
 * test cases for the for the configuration
 *
 * @author Andreas Mecky <andreas.mecky@xcom.de>
 * @author Terry Dye <terry.dye@xcom.de>
 */
public class InheritanceTest extends TestCase {
        
    public InheritanceTest(String name) {
        super(name);
    }
    /**
     *  The main program for the ConfigurationTest class
     *
     *@param  args  The command line arguments
     */
    public static void main(String[] args) {
        junit.textui.TestRunner.run(InheritanceTest.class);
    }
    
    protected void setUp() {
        System.setProperty("jconfig.parser", NestedConfigParser.class.getName());    
    }
    
    protected void tearDown() {
    }
    
    public void testGetAllCategoryNames() {
        Configuration cfg = ConfigurationManager.getConfiguration("inheritance");
        String[] names = cfg.getCategoryNames();
        assertEquals(9,names.length);        
    }
    
    public void testGetNumberOfCategories() {
        Configuration cfg = ConfigurationManager.getConfiguration("inheritance");
        int cnt = cfg.getNumberOfCategories();
        assertEquals(9,cnt);        
    }
    
    public void testGetProperties() {
        Configuration cfg = ConfigurationManager.getConfiguration("inheritance");
        Properties props = cfg.getProperties(); 
        assertEquals(4,props.size());
    }
    
    public void testSaveConfig() {
        Configuration cfg = ConfigurationManager.getConfiguration("inheritance");
        try {
            String fileName = System.getProperty("java.io.tmpdir")+File.separator+"test_config.xml";                        
            XMLFileHandler handler = new XMLFileHandler(fileName);
            handler.store(cfg);
        }
        catch (Exception e) {
            e.printStackTrace();
            fail("unexpected exception");
        }
    }
    
}
